#!/usr/bin/perl

#system("perl ./make_data_comp.pl");

$TIME_TIMEOUT=600;
$TIME_MEMOUT=2*$TIME_TIMEOUT;
$TIME_NOTRUN=$TIME_MEMOUT*2;
$TIME_SCALE=$TIME_NOTRUN*2;

# list of [prefix,title,scatter_prefix]
@yo = (["logBuchi-","Buchi","Buchi"],
       ["logWABA-","WABA full unroll", "WABA_fu"],
       ["logWABA1-","WABA unroll=1", "WABA_u1"],
       ["logM-H-","Miyano-Hayashi", "MH"]);

$i = 0;
$length = @yo;
$pref1=$yo[1]->[0];
#$title1="Max comp size";
$spref1=$yo[1]->[2];

    
$pref2=$yo[3]->[0];
#$title2="Frequency";
$spref2=$yo[3]->[2];

$s1="Data/$pref1.dat";
$s2="Data/$pref2.dat";
$out="Scatter_plots_Aut/aut_compdist.eps";

find_different_cex_length($s1,$title1,$title2,$out);
exit;

sub find_different_cex_length {
    open(S1, "$s1");
    open(S2, "$s2");
    open(TMPuu, ">Temp/scatter_data_uu");
    
    %distribution;
    while(<S1>) {
	$s1_line = $_;
	$s2_line = <S2>;
	chop($s1_line);
	chop($s2_line);
	@info1 = split(/ /, $s1_line);
	@info2 = split(/ /, $s2_line);

	if ($info1[1] eq 'F' && $info2[1] eq 'F') {
	    print $info1[1], $info2[1], "\n";
	    $length1=$info1[2];
	    $length2=$info2[2];
	    if ($length1 > $length2) {
		print TMPuu "$info1[0]\n";
	    }
	}

    }
    close(S1);
    close(S2);
    close(TMPuu);
}






sub find_aut_non_vwaba {
    open(S1, "$s1");
    open(TMPuu, ">Temp/scatter_data_uu");
    open (WABA, ">Data/waba.dat");
    open (VWABA, ">Data/vwaba.dat");
    
    %distribution;
    while(<S1>) {
	$s1_line = $_;
	chop($s1_line);
	@info = split(/ /, $s1_line);
	$max=$info[5];
	if (! exists $distribution{$max}) {
	    $distribution{$max}=1;
	}
	else {
	    $distribution{$max}=$distribution{$max}+1;
	}
	if ($max>1) {
	    print WABA "$info[0] $max \n";
	}
	else {
	    print VWABA "$info[0] $max \n";
	}

    }

    $sum=0;
    foreach $key (sort(keys %distribution)) { 
	print TMPuu $key, ' ', $distribution{$key}, "\n";
	print "Key: ", $key, " Value: ", $distribution{$key}, "\n";
	$sum=$sum+$distribution{$key};
    }
    print "Total: ", $sum, "\n";

    close(S1);
    close(TMPuu);
    close(WABA);
    close(VWABA);
}









sub do_plot_bound_vs_maxcomp {
    $pref1="logWABA-";
    $title1="Max comp size";
        
    $title2="Bound Reached";
    
    $s1="Data/$pref1.dat";
    
    $out="Scatter_plots_Aut/aut_bound_vs_maxcomp.eps";
    print "making $out\n";

    open(S1, "$s1");
    open(TMPuu, ">Temp/scatter_data_uu");
    
    %distribution;
    while(<S1>) {
	$s1_line = $_;
	chop($s1_line);
	@info = split(/ /, $s1_line);
	$bound=@info[2];
	$max=$info[5];
	print TMPuu $max, ' ', $bound, "\n";
#	if (! exists $distribution{$max}) {
#	    $distribution{$max}=1;
#	}
#	else {
#	    $distribution{$max}=$distribution{$max}+1;
#	}
    }

#    foreach $key (sort(keys %distribution)) { 
#	print TMPuu $key, ' ', $distribution{$key}, "\n";
#    }
    close(S1);
    close(TMPuu);
    
    open(TMP, ">Temp/make_plot.gpl");
    print TMP "set out '$out'\n";
    print TMP "set terminal postscript eps color\n";
    print TMP "set log\n";
    print TMP "set autoscale\n";
#    print TMP "set size square\n";
#    print TMP "set xrange [0.9:1000]\n";
#    print TMP "set yrange [0.5:1000]\n";
    print TMP "set xlabel \"$title1\"\n";
    print TMP "set ylabel \"$title2\"\n";
 #   print TMP "set arrow from 0.01,$TIME_TIMEOUT to $TIME_SCALE,$TIME_TIMEOUT nohead\n";
 #   print TMP "set arrow from 0.01,$TIME_MEMOUT to $TIME_SCALE,$TIME_MEMOUT nohead\n";
 #   print TMP "set arrow from 0.01,$TIME_NOTRUN to $TIME_SCALE,$TIME_NOTRUN nohead\n";
#    print TMP "set arrow from 0.01,28800 to 60000,28800 nohead\n";
#    print TMP "set arrow from $TIME_TIMEOUT, graph 0 to $TIME_TIMEOUT, graph 1 nohead\n";
#    print TMP "set arrow from $TIME_MEMOUT, graph 0 to $TIME_MEMOUT, graph 1 nohead\n";
#    print TMP "set arrow from $TIME_NOTRUN, graph 0 to $TIME_NOTRUN, graph 1 nohead\n";
#    print TMP "set arrow from 28800, graph 0 to 28800, graph 1 nohead\n";
#    print TMP "plot \"scatter_data_tmpt\" using 2:3 title \"\" with points lt -1 pt 12, \"scatter_data_tmpf\" using 2:3 title \"\" with points lt 1 pt 4, x title \"\"\n";
    print TMP "plot ";
    print TMP "\"Temp/scatter_data_uu\" using 1:2 title \"\" with points lt -1 pt 12, ";
    print TMP "x title \"\"\n";
    print TMP "quit\n";
    close(TMP);

    system("gnuplot < Temp/make_plot.gpl");
}



sub do_plot_aut_size_vs_bound {
    $pref1="logWABA-";
    $title1="Automaton size";
        
    $title2="Bound Reached";
    
    $s1="Data/$pref1.dat";
    
    $out="Scatter_plots_Aut/aut_size_vs_bound.eps";
    print "making $out\n";

    open(S1, "$s1");
    open(TMPuu, ">Temp/scatter_data_uu");
    
    %distribution;
    while(<S1>) {
	$s1_line = $_;
	chop($s1_line);
	@info = split(/ /, $s1_line);
	$bound=@info[2];
	$max=0;
	for $x (5..$#info) {
	    $max=$max+$info[$x];
	}
	print TMPuu $max, ' ', $bound, "\n";
#	if (! exists $distribution{$max}) {
#	    $distribution{$max}=1;
#	}
#	else {
#	    $distribution{$max}=$distribution{$max}+1;
#	}
    }

#    foreach $key (sort(keys %distribution)) { 
#	print TMPuu $key, ' ', $distribution{$key}, "\n";
#    }
    close(S1);
    close(TMPuu);
    
    open(TMP, ">Temp/make_plot.gpl");
    print TMP "set out '$out'\n";
    print TMP "set terminal postscript eps color\n";
    print TMP "set log\n";
    print TMP "set autoscale\n";
#    print TMP "set size square\n";
#    print TMP "set xrange [0.9:1000]\n";
#    print TMP "set yrange [0.5:1000]\n";
    print TMP "set xlabel \"$title1\"\n";
    print TMP "set ylabel \"$title2\"\n";
 #   print TMP "set arrow from 0.01,$TIME_TIMEOUT to $TIME_SCALE,$TIME_TIMEOUT nohead\n";
 #   print TMP "set arrow from 0.01,$TIME_MEMOUT to $TIME_SCALE,$TIME_MEMOUT nohead\n";
 #   print TMP "set arrow from 0.01,$TIME_NOTRUN to $TIME_SCALE,$TIME_NOTRUN nohead\n";
#    print TMP "set arrow from 0.01,28800 to 60000,28800 nohead\n";
#    print TMP "set arrow from $TIME_TIMEOUT, graph 0 to $TIME_TIMEOUT, graph 1 nohead\n";
#    print TMP "set arrow from $TIME_MEMOUT, graph 0 to $TIME_MEMOUT, graph 1 nohead\n";
#    print TMP "set arrow from $TIME_NOTRUN, graph 0 to $TIME_NOTRUN, graph 1 nohead\n";
#    print TMP "set arrow from 28800, graph 0 to 28800, graph 1 nohead\n";
#    print TMP "plot \"scatter_data_tmpt\" using 2:3 title \"\" with points lt -1 pt 12, \"scatter_data_tmpf\" using 2:3 title \"\" with points lt 1 pt 4, x title \"\"\n";
    print TMP "plot ";
    print TMP "\"Temp/scatter_data_uu\" using 1:2 title \"\" with points lt -1 pt 12, ";
    print TMP "x title \"\"\n";
    print TMP "quit\n";
    close(TMP);

    system("gnuplot < Temp/make_plot.gpl");
}




sub do_plot_aut_sizedist {
    open(S1, "$s1");
    open(TMPuu, ">Temp/scatter_data_uu");
    
    %distribution;
    while(<S1>) {
	$s1_line = $_;
	chop($s1_line);
	@info = split(/ /, $s1_line);
	$max=0;
	for $x (5..$#info) {
	    $max=$max+$info[$x];
	}
	if (! exists $distribution{$max}) {
	    $distribution{$max}=1;
	}
	else {
	    $distribution{$max}=$distribution{$max}+1;
	}
    }

    foreach $key (sort(keys %distribution)) { 
	print TMPuu $key, ' ', $distribution{$key}, "\n";
    }
    close(S1);
    close(TMPuu);
    
    open(TMP, ">Temp/make_plot.gpl");
    print TMP "set out '$out'\n";
    print TMP "set terminal postscript eps color\n";
    print TMP "set log\n";
    print TMP "set autoscale\n";
#    print TMP "set size square\n";
    print TMP "set xrange [0.9:1000]\n";
    print TMP "set yrange [0.5:1000]\n";
    print TMP "set xlabel \"$title1\"\n";
    print TMP "set ylabel \"$title2\"\n";
 #   print TMP "set arrow from 0.01,$TIME_TIMEOUT to $TIME_SCALE,$TIME_TIMEOUT nohead\n";
 #   print TMP "set arrow from 0.01,$TIME_MEMOUT to $TIME_SCALE,$TIME_MEMOUT nohead\n";
 #   print TMP "set arrow from 0.01,$TIME_NOTRUN to $TIME_SCALE,$TIME_NOTRUN nohead\n";
#    print TMP "set arrow from 0.01,28800 to 60000,28800 nohead\n";
#    print TMP "set arrow from $TIME_TIMEOUT, graph 0 to $TIME_TIMEOUT, graph 1 nohead\n";
#    print TMP "set arrow from $TIME_MEMOUT, graph 0 to $TIME_MEMOUT, graph 1 nohead\n";
#    print TMP "set arrow from $TIME_NOTRUN, graph 0 to $TIME_NOTRUN, graph 1 nohead\n";
#    print TMP "set arrow from 28800, graph 0 to 28800, graph 1 nohead\n";
#    print TMP "plot \"scatter_data_tmpt\" using 2:3 title \"\" with points lt -1 pt 12, \"scatter_data_tmpf\" using 2:3 title \"\" with points lt 1 pt 4, x title \"\"\n";
    print TMP "plot ";
    print TMP "\"Temp/scatter_data_uu\" using 1:2 title \"\" with impulses, ";
    print TMP "x title \"\"\n";
    print TMP "quit\n";
    close(TMP);

    system("gnuplot < Temp/make_plot.gpl");
}





sub do_plot_aut_compdist {
    open(S1, "$s1");
    open(TMPuu, ">Temp/scatter_data_uu");
    
    %distribution;
    while(<S1>) {
	$s1_line = $_;
	chop($s1_line);
	@info = split(/ /, $s1_line);
	$max=$info[5];
	if (! exists $distribution{$max}) {
	    $distribution{$max}=1;
	}
	else {
	    $distribution{$max}=$distribution{$max}+1;
	}
    }

    $sum=0;
    foreach $key (sort(keys %distribution)) { 
	print TMPuu $key, ' ', $distribution{$key}, "\n";
	print "Key: ", $key, " Value: ", $distribution{$key}, "\n";
	$sum=$sum+$distribution{$key};
    }
    print "Total: ", $sum, "\n";

    close(S1);
    close(TMPuu);
    
    open(TMP, ">Temp/make_plot.gpl");
    print TMP "set out '$out'\n";
    print TMP "set terminal postscript eps color\n";
    print TMP "set log\n";
    print TMP "set autoscale\n";
#    print TMP "set size square\n";
    print TMP "set xrange [0.9:1000]\n";
    print TMP "set yrange [0.5:1000]\n";
    print TMP "set xlabel \"$title1\"\n";
    print TMP "set ylabel \"$title2\"\n";
 #   print TMP "set arrow from 0.01,$TIME_TIMEOUT to $TIME_SCALE,$TIME_TIMEOUT nohead\n";
 #   print TMP "set arrow from 0.01,$TIME_MEMOUT to $TIME_SCALE,$TIME_MEMOUT nohead\n";
 #   print TMP "set arrow from 0.01,$TIME_NOTRUN to $TIME_SCALE,$TIME_NOTRUN nohead\n";
#    print TMP "set arrow from 0.01,28800 to 60000,28800 nohead\n";
#    print TMP "set arrow from $TIME_TIMEOUT, graph 0 to $TIME_TIMEOUT, graph 1 nohead\n";
#    print TMP "set arrow from $TIME_MEMOUT, graph 0 to $TIME_MEMOUT, graph 1 nohead\n";
#    print TMP "set arrow from $TIME_NOTRUN, graph 0 to $TIME_NOTRUN, graph 1 nohead\n";
#    print TMP "set arrow from 28800, graph 0 to 28800, graph 1 nohead\n";
#    print TMP "plot \"scatter_data_tmpt\" using 2:3 title \"\" with points lt -1 pt 12, \"scatter_data_tmpf\" using 2:3 title \"\" with points lt 1 pt 4, x title \"\"\n";
    print TMP "plot ";
    print TMP "\"Temp/scatter_data_uu\" using 1:2 title \"\" with impulses, ";
    print TMP "x title \"\"\n";
    print TMP "quit\n";
    close(TMP);

    system("gnuplot < Temp/make_plot.gpl");
}




sub do_plot_time {
    open(S1, "$s1");
    open(S2, "$s2");
    open(TMPuu, ">Temp/scatter_data_uu");
    open(TMPuk, ">Temp/scatter_data_uk");
    open(TMPku, ">Temp/scatter_data_ku");
    open(TMPkk, ">Temp/scatter_data_kk");
    
    $index = 0;
    while(<S1>) {
	$s1_line = $_;
	$s2_line = <S2>;
	chop($s1_line);
	chop($s2_line);
	($f1,$sol1,$k1,$t1) = split(/ /, $s1_line);
	($f2,$sol2,$k2,$t2) = split(/ /, $s2_line);
	if(! ($f1 eq $f2)) {
	    die "Internal error";
	}
	if(($sol1 eq "T") && ($sol2 eq "F")) {
	    die "Internal error: different solutions while processing $f1";
	}
	if(($sol1 eq "F") && ($sol2 eq "T")) {
	    die "Internal error: different solutions while processing $f1";
	}

	if($sol1 eq "?") {
	    if($sol2 eq "?") {
		print TMPuu "$index $t1 $t2\n";
	    }
	    else {
		print TMPuk "$index $t1 $t2\n";
	    }
	}
	else {
	    if($sol2 eq "?") {
		print TMPku "$index $t1 $t2\n";
	    }
	    else {
		print TMPkk "$index $t1 $t2\n";
	    }
	}
	$index = $index+1;
    }
    close(S1);
    close(S2);
    close(TMPuu);
    close(TMPuk);
    close(TMPku);
    close(TMPkk);
    
    open(TMP, ">Temp/make_plot.gpl");
    print TMP "set out '$out'\n";
    print TMP "set terminal postscript eps color\n";
    print TMP "set log\n";
    print TMP "set autoscale\n";
    print TMP "set size square\n";
    print TMP "set xrange [0.01:$TIME_SCALE]\n";
    print TMP "set yrange [0.01:$TIME_SCALE]\n";
    print TMP "set xlabel \"$title1\"\n";
    print TMP "set ylabel \"$title2\"\n";
#    print TMP "set title \"time\"\n";
#    print TMP "set arrow from 0.01,7200 to 60000,7200 nohead\n";
#    print TMP "set arrow from 0.01,14400 to 60000,14400 nohead\n";
    print TMP "set arrow from 0.01,$TIME_TIMEOUT to $TIME_SCALE,$TIME_TIMEOUT nohead\n";
    print TMP "set arrow from 0.01,$TIME_MEMOUT to $TIME_SCALE,$TIME_MEMOUT nohead\n";
    print TMP "set arrow from 0.01,$TIME_NOTRUN to $TIME_SCALE,$TIME_NOTRUN nohead\n";
#    print TMP "set arrow from 0.01,28800 to 60000,28800 nohead\n";
    print TMP "set arrow from $TIME_TIMEOUT, graph 0 to $TIME_TIMEOUT, graph 1 nohead\n";
    print TMP "set arrow from $TIME_MEMOUT, graph 0 to $TIME_MEMOUT, graph 1 nohead\n";
    print TMP "set arrow from $TIME_NOTRUN, graph 0 to $TIME_NOTRUN, graph 1 nohead\n";
#    print TMP "set arrow from 28800, graph 0 to 28800, graph 1 nohead\n";
#    print TMP "plot \"scatter_data_tmpt\" using 2:3 title \"\" with points lt -1 pt 12, \"scatter_data_tmpf\" using 2:3 title \"\" with points lt 1 pt 4, x title \"\"\n";
    print TMP "plot ";
    if(-s "Temp/scatter_data_uu") {
	print TMP "\"Temp/scatter_data_uu\" using 2:3 title \"\" with points lt -1 pt 12, ";
    }
    if(-s "Temp/scatter_data_uk") {
	print TMP "\"Temp/scatter_data_uk\" using 2:3 title \"\" with points lt -1 pt 4, ";
    }
    if(-s "Temp/scatter_data_ku") {
	print TMP "\"Temp/scatter_data_ku\" using 2:3 title \"\" with points lt 1 pt 12, ";
    }
    if(-s "Temp/scatter_data_kk") {
	print  TMP"\"Temp/scatter_data_kk\" using 2:3 title \"\" with points lt 1 pt 4, ";
    }
    print TMP "x title \"\"\n";
    print TMP "quit\n";
    close(TMP);

    system("gnuplot < Temp/make_plot.gpl");
}



sub do_plot_bound {
    open(S1, "$s1");
    open(S2, "$s2");
    open(TMPuu, ">Temp/scatter_data_uu");
    open(TMPuk, ">Temp/scatter_data_uk");
    open(TMPku, ">Temp/scatter_data_ku");
    open(TMPkk, ">Temp/scatter_data_kk");
    
    $index = 0;
    while(<S1>) {
	$s1_line = $_;
	$s2_line = <S2>;
	chop($s1_line);
	chop($s2_line);
	($f1,$sol1,$k1,$t1) = split(/ /, $s1_line);
	($f2,$sol2,$k2,$t2) = split(/ /, $s2_line);
	if(! ($f1 eq $f2)) {
	    die "Internal error";
	}
	if(($sol1 eq "T") && ($sol2 eq "F")) {
	    die "Internal error: different solutions while processing $f1";
	}
	if(($sol1 eq "F") && ($sol2 eq "T")) {
	    die "Internal error: different solutions while processing $f1";
	}

	if($sol1 eq "?") {
	    if($sol2 eq "?") {
		print TMPuu "$index ". ($k1 - 0.2) ." ". ($k2 - 0.2) ."\n";
	    }
	    else {
		print TMPuk "$index ". ($k1 - 0.2) ." ". ($k2) ."\n";
	    }
	}
	else {
	    if($sol2 eq "?") {
		print TMPku "$index ". ($k1) ." ". ($k2 - 0.2) ."\n";
	    }
	    else {
		print TMPkk "$index ". ($k1) ." ". ($k2) ."\n";
	    }
	}
	$index = $index+1;
    }
    close(S1);
    close(S2);
    close(TMPuu);
    close(TMPuk);
    close(TMPku);
    close(TMPkk);

    open(TMP, ">Temp/make_plot.gpl");
    print TMP "set out '$out'\n";
    print TMP "set terminal postscript eps color\n";
    print TMP "set log\n";
    print TMP "set autoscale\n";
    print TMP "set size square\n";
#    print TMP "set xrange [0.01:$TIME_SCALE]\n";
#    print TMP "set yrange [0.01:$TIME_SCALE]\n";
    print TMP "set xlabel \"$title1\"\n";
    print TMP "set ylabel \"$title2\"\n";
#    print TMP "set title \"time\"\n";
#    print TMP "set arrow from 0.01,7200 to 60000,7200 nohead\n";
#    print TMP "set arrow from 0.01,14400 to 60000,14400 nohead\n";
#    print TMP "set arrow from 0.01,$TIME_TIMEOUT to $TIME_SCALE,$TIME_TIMEOUT nohead\n";
#    print TMP "set arrow from 0.01,$TIME_MEMOUT to $TIME_SCALE,$TIME_MEMOUT nohead\n";
#    print TMP "set arrow from 0.01,$TIME_NOTRUN to $TIME_SCALE,$TIME_NOTRUN nohead\n";
#    print TMP "set arrow from 0.01,28800 to 60000,28800 nohead\n";
#    print TMP "set arrow from $TIME_TIMEOUT, graph 0 to $TIME_TIMEOUT, graph 1 nohead\n";
#    print TMP "set arrow from $TIME_MEMOUT, graph 0 to $TIME_MEMOUT, graph 1 nohead\n";
#    print TMP "set arrow from $TIME_NOTRUN, graph 0 to $TIME_NOTRUN, graph 1 nohead\n";
#    print TMP "set arrow from 28800, graph 0 to 28800, graph 1 nohead\n";
    print TMP "plot ";
    if(-s "Temp/scatter_data_uu") {
	print TMP "\"Temp/scatter_data_uu\" using 2:3 title \"\" with points lt -1 pt 12, ";
    }
    if(-s "Temp/scatter_data_uk") {
	print TMP "\"Temp/scatter_data_uk\" using 2:3 title \"\" with points lt -1 pt 4, ";
    }
    if(-s "Temp/scatter_data_ku") {
	print TMP "\"Temp/scatter_data_ku\" using 2:3 title \"\" with points lt 1 pt 12, ";
    }
    if(-s "Temp/scatter_data_kk") {
	print  TMP"\"Temp/scatter_data_kk\" using 2:3 title \"\" with points lt 1 pt 4, ";
    }
    print TMP "x title \"\"\n";
    print TMP "quit\n";
    close(TMP);

    system("gnuplot < Temp/make_plot.gpl");
}
