#!/usr/bin/perl

$BDIR="/home/tlatvala/projects/NuSMV2-psl/nusmv/benchmark/non-vwaba";
$TIMELIMIT=600;
$TIME_TIMEOUT=$TIMELIMIT;
$TIME_MEMOUT=2*$TIME_TIMEOUT;
$TIME_NOTRUN=$TIME_TIMEOUT*4;
$BOUND_NOTRUN=5000;

# list of [prefix,title,scatter_prefix]
@yo = (["logBuchi-","Buchi","Buchi"],
       ["logWABA-","WABA full unroll", "WABA_fu"],
       ["logWABA1-","WABA unroll=1", "WABA_u1"],
       ["logM-H-","Miyano-Hayashi", "MH"]);

foreach my $m (@yo) {
    $pref=$m->[0];
    
    print "Collecting data for '$pref'\n";
    open(DATA, ">Data/$pref.dat");
    while ($file = <$BDIR/model-*.txt>) {
	$f = $file;
	$f =~ s%model-%$pref%;
	make_row($file,$f);
    }
    close(DATA);
}


sub get_time {
    local($f);
    local($s);
    $f = $_[0];
    $s = $_[1];
    $time = $TIME_NOTRUN;
    open(FILE, $f);
    if(-s FILE) {
        while($line = <FILE>) {
            if($line =~ "([0-9]*\.?[0-9]*)user.*") {
                $time = $1;
                last;
            }
        }
        close(FILE);
        if($time < 0.01) {
            $time = "0.01";
        }
        if($s eq "?") {
            # No solution, interpret time
            if($time <= $TIMELIMIT-20) {
		#only valid if the k is unbounded
                $time = $TIME_MEMOUT;
            } else {
                $time = $TIME_TIMEOUT;
            }
        }
        $time;
    }
    else {
        # No time file, the benchmark was apparently not run
        $time;
    }
}



sub make_row {
    local($file);
    local($f);
    $file = $_[0];
    $f = $_[1];

    $outfile = $f . ".out";
    $timefile = $f . ".time";
    $sol = "?";
    $k = $BOUND_NOTRUN;
    $ct = "0";
    open(FILE, $outfile);
    if(-e FILE) {
        while($line = <FILE>) {
            if($line =~ "TJ: .*, k=(.*), solver time=(.*).*, cumulative time=([0-9]*)\.[0-9]?.*\.\n") {
                $k = $1;
                $st = $2;
                $ct = $3;
            }
            if($line =~ "-- specification .* is true.*") {
                $sol = "T";
            }
            if($line =~ "-- specification .* is false.*") {
                $sol = "F";
            }
        }
    }
    $ct = &get_time($timefile,$sol);
    print DATA "$file $sol $k $time\n";
}
