#!/usr/bin/perl

#system("perl ./make_data.pl");

$TIME_TIMEOUT=600;
$TIME_MEMOUT=2*$TIME_TIMEOUT;
$TIME_NOTRUN=$TIME_MEMOUT*2;
$TIME_SCALE=$TIME_NOTRUN;

# list of [prefix,title,scatter_prefix]
@yo = (["logBuchi-","BMC on Buchi automaton from the WABA","Buchi"],
       ["logWABA-","new WABA encoding, minimal counterexamples", "WABA_fu"],
       ["logWABA1-","new linear WABA encoding ", "WABA_u1"],
       ["logM-H-","symbolic Miyano-Hayashi BMC encoding", "MH"]);

$i = 0;
$length = @yo;
foreach my $m1 (@yo) {
    $pref1=$m1->[0];
    $title1=$m1->[1];
    $spref1=$m1->[2];

    foreach my $m2 (@yo) {
	if($m1 == $m2) {
	    next;
	}
	$pref2=$m2->[0];
	$title2=$m2->[1];
	$spref2=$m2->[2];

	$s1="Data/$pref1.dat";
	$s2="Data/$pref2.dat";

	$out="Scatter_plots_time/$spref1"."_vs_"."$spref2.eps";
	print "making $out\n";
	do_plot_time($s1,$title1,$s2,$title2,$out);

	$out="Scatter_plots_bound/$spref1"."_vs_"."$spref2.eps";
	print "making $out\n";
	do_plot_bound($s1,$title1,$s2,$title2,$out);
    }
}
exit;

sub do_plot_time {
    open(S1, "$s1");
    open(S2, "$s2");
    open(TMPuu, ">Temp/scatter_data_uu");
    open(TMPuk, ">Temp/scatter_data_uk");
    open(TMPku, ">Temp/scatter_data_ku");
    open(TMPkk, ">Temp/scatter_data_kk");
    
    $index = 0;
    while(<S1>) {
	$s1_line = $_;
	$s2_line = <S2>;
	chop($s1_line);
	chop($s2_line);
	@info = split(/ /, $s1_line);
	@info2 = split(/ /, $s2_line);
	($f1,$sol1,$k1,$t1) = @info[0..3];
	($f2,$sol2,$k2,$t2) =  @info2[0..3];
	$max1=0; 
	$max2=0;
	if(@info > 4) { 
	    $max1=$info[5];
        } 
	if (@info2 > 4) {
	    $max2=$info2[5];
	}


	if(! ($f1 eq $f2)) {
	    die "Internal error";
	}
	if(($sol1 eq "T") && ($sol2 eq "F")) {
	    die "Internal error: different solutions while processing $f1";
	}
	if(($sol1 eq "F") && ($sol2 eq "T")) {
	    die "Internal error: different solutions while processing $f1";
	}

#	if($max1>1 || $max2 > 1) {
	    if($sol1 eq "?") {
		if($sol2 eq "?") {
		    print TMPuu "$index $t1 $t2\n";
		}
		else {
		    print TMPuk "$index $t1 $t2\n";
		}
	    }
	    else {
		if($sol2 eq "?") {
		    print TMPku "$index $t1 $t2\n";
		}
		else {
		    print TMPkk "$index $t1 $t2\n";
		}
	    }
	    $index = $index+1;
	    $cnt=$cnt+1;
	}
#    }
    print "The count: ", $index, "\n";
    close(S1);
    close(S2);
    close(TMPuu);
    close(TMPuk);
    close(TMPku);
    close(TMPkk);
    
    open(TMP, ">Temp/make_plot.gpl");
    print TMP "set out '$out'\n";
    print TMP "set terminal postscript eps color\n";
    print TMP "set log\n";
    print TMP "set autoscale\n";
    print TMP "set size square\n";
    print TMP "set xrange [0.1:$TIME_SCALE]\n";
    print TMP "set yrange [0.1:$TIME_SCALE]\n";
    print TMP "set xlabel \"$title1\"\n";
    print TMP "set ylabel \"$title2\"\n";
    print TMP "set title \"time\"\n";
#    print TMP "set arrow from 0.01,7200 to 60000,7200 nohead\n";
#    print TMP "set arrow from 0.01,14400 to 60000,14400 nohead\n";
    print TMP "set arrow from 0.1,$TIME_TIMEOUT to $TIME_SCALE,$TIME_TIMEOUT nohead\n";
#    print TMP "set arrow from 0.01,$TIME_MEMOUT to $TIME_SCALE,$TIME_MEMOUT nohead\n";
#    print TMP "set arrow from 0.01,$TIME_NOTRUN to $TIME_SCALE,$TIME_NOTRUN nohead\n";
#    print TMP "set arrow from 0.01,28800 to 60000,28800 nohead\n";
    print TMP "set arrow from $TIME_TIMEOUT, graph 0 to $TIME_TIMEOUT, graph 1 nohead\n";
#    print TMP "set arrow from $TIME_MEMOUT, graph 0 to $TIME_MEMOUT, graph 1 nohead\n";
#    print TMP "set arrow from $TIME_NOTRUN, graph 0 to $TIME_NOTRUN, graph 1 nohead\n";
#    print TMP "set arrow from 28800, graph 0 to 28800, graph 1 nohead\n";
#    print TMP "plot \"scatter_data_tmpt\" using 2:3 title \"\" with points lt -1 pt 12, \"scatter_data_tmpf\" using 2:3 title \"\" with points lt 1 pt 4, x title \"\"\n";
    print TMP "plot ";
    if(-s "Temp/scatter_data_uu") {
	print TMP "\"Temp/scatter_data_uu\" using 2:3 title \"\" with points lt -1 pt 12, ";
    }
#    if(-s "Temp/scatter_data_uk") {
#	print TMP "\"Temp/scatter_data_uk\" using 2:3 title \"\" with points lt -1 pt 4, ";
#    }
#    if(-s "Temp/scatter_data_ku") {
#	print TMP "\"Temp/scatter_data_ku\" using 2:3 title \"\" with points lt 1 pt 12, ";
#    }
    if(-s "Temp/scatter_data_kk") {
	print  TMP"\"Temp/scatter_data_kk\" using 2:3 title \"\" with points lt 1 pt 4, ";
    }
    print TMP "x title \"\"\n";
    print TMP "quit\n";
    close(TMP);

    system("gnuplot < Temp/make_plot.gpl");
}


sub do_plot_bound {
    open(S1, "$s1");
    open(S2, "$s2");
    open(TMPuu, ">Temp/scatter_data_uu");
    open(TMPuk, ">Temp/scatter_data_uk");
    open(TMPku, ">Temp/scatter_data_ku");
    open(TMPkk, ">Temp/scatter_data_kk");
    
    $index = 0;
    while(<S1>) {
	$s1_line = $_;
	$s2_line = <S2>;
	chop($s1_line);
	chop($s2_line);
	@info = split(/ /, $s1_line);
	@info2 = split(/ /, $s2_line);
	($f1,$sol1,$k1,$t1) = @info[0..3];
	($f2,$sol2,$k2,$t2) =  @info2[0..3];
	$max1=0;
	$max2=0;
	
	if(@info > 5){
	    $max1=$info[5];
	}
	if(@info2 > 5) {
	    $max2=$info2[5]
	}

	if(! ($f1 eq $f2)) {
	    die "Internal error";
	}
	if(($sol1 eq "T") && ($sol2 eq "F")) {
	    die "Internal error: different solutions while processing $f1";
	}
	if(($sol1 eq "F") && ($sol2 eq "T")) {
	    die "Internal error: different solutions while processing $f1";
	}

	
#	if($max1>1 || $max2>1) {
	    if($sol1 eq "?") {
		if($sol2 eq "?") {
		    print TMPuu "$index ". ($k1 - 0.2) ." ". ($k2 - 0.2) ."\n";
		}
		else {
		    print TMPuk "$index ". ($k1 - 0.2) ." ". ($k2) ."\n";
		}
	    }
	    else {
		if($sol2 eq "?") {
		    print TMPku "$index ". ($k1) ." ". ($k2 - 0.2) ."\n";
		}
		else {
		    print TMPkk "$index ". ($k1) ." ". ($k2) ."\n";
		}
	    }
	    $index = $index+1;
	}
#    }
    print "The count: ", $index, "\n";
    close(S1);
    close(S2);
    close(TMPuu);
    close(TMPuk);
    close(TMPku);
    close(TMPkk);

    open(TMP, ">Temp/make_plot.gpl");
    print TMP "set out '$out'\n";
    print TMP "set terminal postscript eps color\n";
    print TMP "set log\n";
    print TMP "set autoscale\n";
    print TMP "set size square\n";
    print TMP "set xrange [1:2000]\n";
    print TMP "set yrange [1:2000]\n";
    print TMP "set xlabel \"$title1\"\n";
    print TMP "set ylabel \"$title2\"\n";
    print TMP "set title \"bound\"\n";
#    print TMP "set arrow from 0.01,7200 to 60000,7200 nohead\n";
#    print TMP "set arrow from 0.01,14400 to 60000,14400 nohead\n";
#    print TMP "set arrow from 0.01,$TIME_TIMEOUT to $TIME_SCALE,$TIME_TIMEOUT nohead\n";
#    print TMP "set arrow from 0.01,$TIME_MEMOUT to $TIME_SCALE,$TIME_MEMOUT nohead\n";
#    print TMP "set arrow from 0.01,$TIME_NOTRUN to $TIME_SCALE,$TIME_NOTRUN nohead\n";
#    print TMP "set arrow from 0.01,28800 to 60000,28800 nohead\n";
#    print TMP "set arrow from $TIME_TIMEOUT, graph 0 to $TIME_TIMEOUT, graph 1 nohead\n";
#    print TMP "set arrow from $TIME_MEMOUT, graph 0 to $TIME_MEMOUT, graph 1 nohead\n";
#    print TMP "set arrow from $TIME_NOTRUN, graph 0 to $TIME_NOTRUN, graph 1 nohead\n";
#    print TMP "set arrow from 28800, graph 0 to 28800, graph 1 nohead\n";
    print TMP "plot ";
    if(-s "Temp/scatter_data_uu") {
	print TMP "\"Temp/scatter_data_uu\" using 2:3 title \"\" with points lt -1 pt 12, ";
    }
#    if(-s "Temp/scatter_data_uk") {
#	print TMP "\"Temp/scatter_data_uk\" using 2:3 title \"\" with points lt -1 pt 4, ";
#    }
#    if(-s "Temp/scatter_data_ku") {
#	print TMP "\"Temp/scatter_data_ku\" using 2:3 title \"\" with points lt 1 pt 12, ";
#    }
    if(-s "Temp/scatter_data_kk") {
	print  TMP"\"Temp/scatter_data_kk\" using 2:3 title \"\" with points lt 1 pt 4, ";
    }
    print TMP "x title \"\"\n";
    print TMP "quit\n";
    close(TMP);

    system("gnuplot < Temp/make_plot.gpl");
}
